# VariableKind

Enum in [Yarn](/api/csharp/yarn.md)

Inherits from `System.Enum`

## Summary

Represents different kinds of variables that can be fetched from a [Dialogue](/api/csharp/yarn/yarn.dialogue.md) using [TryGetValue\<T>(string,T?)](/api/csharp/yarn/yarn.ivariableaccess/yarn.ivariableaccess.trygetvalue.md) .

```csharp
public enum VariableKind
{
    Unknown,
    Stored,
    Smart
}
```

## Members

| Name                                                                       | Description                                                                       |
| -------------------------------------------------------------------------- | --------------------------------------------------------------------------------- |
| [Smart](/api/csharp/yarn/yarn.variablekind/yarn.variablekind.smart.md)     | The variable's value is computed at run-time, and is not persisted to disk.       |
| [Stored](/api/csharp/yarn/yarn.variablekind/yarn.variablekind.stored.md)   | The variable's value is stored in memory, and may be persisted to disk.           |
| [Unknown](/api/csharp/yarn/yarn.variablekind/yarn.variablekind.unknown.md) | The kind of the variable cannot be determined. It may not be known to the system. |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/api/csharp/yarn/yarn.variablekind.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
